/*

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef PARSECQT5PSAUDITFLAGVECTORWIDGET_H
#define PARSECQT5PSAUDITFLAGVECTORWIDGET_H

#include "parsec_aud_qt5_global.h"

#include <parsec/aud.h>
#include <parsec/aud_db.h>

#include <QWidget>
#include <QMap>

class QPushButton;
class QCheckBox;

namespace ParsecQt5
{
    class PARSEC_AUD_QT5_EXPORT  PsAuditFlagVectorWidget : public QWidget
    {
    Q_OBJECT

    public:

        enum Status { Success = 0, Fail = 1 };

        PsAuditFlagVectorWidget( Status status, QWidget *parent );
        virtual ~PsAuditFlagVectorWidget();

        bool setFlagsFrom( audit_entry *e );
        void getFlagsTo( audit_entry *e );

        void clear();

    signals:
        void changed();

    private slots:

        void buttonClicked();
        void allCheckBoxClicked( bool checked );

    private:

        void setAllChecked( bool );

        Qt::CheckState buttonGroupState();
        void fillButtons( QPushButton *single = 0 );
        void updateCheckBox();

        QPushButton *m_openPushButton;
        QPushButton *m_createPushButton;
        QPushButton *m_execPushButton;
        QPushButton *m_deletePushButton;
        QPushButton *m_chmodPushButton;
        QPushButton *m_chownPushButton;
        QPushButton *m_mountPushButton;
        QPushButton *m_modulePushButton;
        QPushButton *m_uidPushButton;
        QPushButton *m_gidPushButton;
        QPushButton *m_auditPushButton;
        QPushButton *m_xattrPushButton;
        QPushButton *m_macPushButton;
        QPushButton *m_capPushButton;
        QPushButton *m_chrootPushButton;
        QPushButton *m_renamePushButton;
        QPushButton *m_netPushButton;

        QCheckBox *m_allCheckBox;
        QMap<audit_ps_t, QPushButton *> m_flagButtonMap;
        Status m_status;
    };
}

#endif // PARSECQT5PSAUDITFLAGVECTORWIDGET_H
